/* A Bison parser, made by GNU Bison 3.0.5.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         SmartsParserparse
#define yylex           SmartsParserlex
#define yyerror         SmartsParsererror
#define yydebug         SmartsParserdebug
#define yynerrs         SmartsParsernerrs

#define yylval          SmartsParserlval
#define yychar          SmartsParserchar

/* Copy the first part of user declarations.  */
#line 1 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:339  */


#include <BALL/STRUCTURE/smartsParser.h>
//#include <iostream>
#include <BALL/KERNEL/PTE.h>

using namespace BALL;
using namespace std;

extern int yylex();
extern void yyerror(char const* s);

#define YYDEBUG 1


#line 90 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "smartsParserParser.h".  */
#ifndef YY_SMARTSPARSER_USR_SRC_RPM_BUILD_BALL_1_4_3_BETA1_793_GIT37FC53C_BUILD_SOURCE_STRUCTURE_SMARTSPARSERPARSER_H_INCLUDED
# define YY_SMARTSPARSER_USR_SRC_RPM_BUILD_BALL_1_4_3_BETA1_793_GIT37FC53C_BUILD_SOURCE_STRUCTURE_SMARTSPARSERPARSER_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int SmartsParserdebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    TK_ATOM = 258,
    TK_ORG_SUBSET_ATOM = 259,
    TK_HYDROGEN_EXPLICIT = 260,
    TK_HYDROGEN_IMPLICIT = 261,
    TK_RECURSIVE = 262,
    TK_AROMATIC_ATOM = 263,
    TK_ALIPHATIC_ATOM = 264,
    TK_ATOM_RING_SIZE = 265,
    TK_ATOM_NUM_RINGS = 266,
    TK_ATOM_VALENCE = 267,
    TK_ATOM_CONNECTED = 268,
    TK_ATOM_RING_CONNECTED = 269,
    TK_ATOM_DEGREE = 270,
    TK_ANY_ATOM = 271,
    TK_CHIRAL_CLASS_TH = 272,
    TK_CHIRAL_CLASS_AL = 273,
    TK_CHIRAL_CLASS_SP = 274,
    TK_CHIRAL_CLASS_TB = 275,
    TK_CHIRAL_CLASS_OH = 276,
    TK_DIGIT = 277,
    TK_ONE_TWO = 278
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 16 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:355  */

	char*														text;
	Index														number;
	SmartsParser::SPAtom*						atom;
	SmartsParser::SPNode*						node;
	SmartsParser::SPEdge*						edge;
	SmartsParser::SPBond*						sp_bond;
	SmartsParser::SPAtom::Property* 	property;

#line 164 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE SmartsParserlval;

int SmartsParserparse (void);

#endif /* !YY_SMARTSPARSER_USR_SRC_RPM_BUILD_BALL_1_4_3_BETA1_793_GIT37FC53C_BUILD_SOURCE_STRUCTURE_SMARTSPARSERPARSER_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 181 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  68
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   488

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  43
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  29
/* YYNRULES -- Number of rules.  */
#define YYNRULES  123
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  154

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   278

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     6,     2,     7,     2,     2,     5,     2,
      32,    33,     2,     9,     4,     8,    34,    35,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    39,     3,
       2,    38,     2,    37,    10,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    41,    36,    42,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,    40,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,    94,    94,    99,   104,   120,   126,   134,   138,   149,
     159,   163,   174,   184,   191,   199,   207,   216,   226,   236,
     249,   253,   257,   261,   265,   269,   273,   277,   281,   288,
     295,   301,   305,   311,   316,   324,   329,   334,   338,   343,
     348,   356,   361,   365,   372,   378,   384,   391,   397,   402,
     408,   416,   420,   426,   432,   437,   442,   446,   452,   457,
     464,   470,   476,   482,   487,   493,   498,   505,   511,   521,
     526,   531,   535,   539,   543,   547,   551,   558,   563,   568,
     573,   578,   583,   588,   596,   600,   605,   610,   614,   618,
     625,   629,   636,   640,   647,   651,   658,   662,   669,   673,
     680,   684,   691,   695,   702,   706,   713,   717,   724,   725,
     726,   727,   731,   732,   733,   734,   738,   742,   749,   750,
     754,   759,   764,   769
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "';'", "','", "'&'", "'!'", "'#'", "'-'",
  "'+'", "'@'", "TK_ATOM", "TK_ORG_SUBSET_ATOM", "TK_HYDROGEN_EXPLICIT",
  "TK_HYDROGEN_IMPLICIT", "TK_RECURSIVE", "TK_AROMATIC_ATOM",
  "TK_ALIPHATIC_ATOM", "TK_ATOM_RING_SIZE", "TK_ATOM_NUM_RINGS",
  "TK_ATOM_VALENCE", "TK_ATOM_CONNECTED", "TK_ATOM_RING_CONNECTED",
  "TK_ATOM_DEGREE", "TK_ANY_ATOM", "TK_CHIRAL_CLASS_TH",
  "TK_CHIRAL_CLASS_AL", "TK_CHIRAL_CLASS_SP", "TK_CHIRAL_CLASS_TB",
  "TK_CHIRAL_CLASS_OH", "TK_DIGIT", "TK_ONE_TWO", "'('", "')'", "'.'",
  "'/'", "'\\\\'", "'?'", "'='", "':'", "'~'", "'['", "']'", "$accept",
  "smarts", "rec_expression", "node_expression", "sp_node", "sp_edge",
  "bond", "ring_bond", "atom_node", "node", "unbraced_atom", "atom",
  "atom_property", "atom_symbol", "unbraced_atom_symbol",
  "implicit_hydrogens", "explicit_hydrogens", "atomic_number", "valence",
  "connected", "ring_connected", "degree", "num_rings", "ring_size",
  "pos_charge", "neg_charge", "connection_list", "isotope", "chirality", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,    59,    44,    38,    33,    35,    45,    43,
      64,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,    40,    41,    46,    47,    92,    63,    61,    58,
     126,    91,    93
};
# endif

#define YYPACT_NINF -73

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-73)))

#define YYTABLE_NINF -1

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     214,   397,   -20,     7,   -73,   -73,   -13,    -5,    14,   -73,
     -73,    19,    20,    22,    23,    24,    30,   -73,   214,   316,
       6,   -73,   -73,   142,   -73,   360,   -73,   -73,   -73,   -73,
      37,   -73,   -73,   -73,   -73,   -73,   -73,   -73,     3,   -73,
     -73,   -73,   -73,   -73,    59,   -73,   -73,   -73,   245,   -73,
     -73,   -73,   -73,   -73,   -73,   -11,   341,    13,     5,   -73,
     -73,     9,   416,   434,   -73,   -73,   377,   -73,   -73,   214,
     281,   -20,   -73,   -73,   178,    -6,     2,   -73,   -73,   -73,
     -73,   106,   -73,   -73,   465,   -73,   -73,   -73,    46,   -73,
     -73,    44,   -73,   -73,   -73,   -73,    71,   -73,    47,   -73,
     316,   316,   316,    60,   450,   -73,   -73,   450,   -73,   -73,
     -73,   -73,   -73,   -73,   -73,   -73,   -73,   -73,    37,    57,
     -73,   -73,    61,   106,   -73,   -73,   132,   132,   132,   -73,
     -73,   -73,   -73,   -73,   -73,   -73,    31,    88,   -73,    46,
     -73,   -73,   -73,   -73,   -73,   -73,   -73,    62,   235,   -73,
      40,    91,   -73,   -73
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,     0,   108,    89,    84,    92,    90,     0,    85,
      86,   106,   104,    96,    98,   100,   102,    87,     0,     0,
       0,    34,     2,     7,    10,    33,    44,    42,    73,    74,
      88,    71,    72,    76,    75,    69,    70,    50,     0,     6,
      43,    41,    49,    94,   109,   111,    93,    91,     0,   107,
     105,    97,    99,   101,   103,     0,     0,   112,   120,   118,
      37,     0,    36,    35,    51,    54,    77,    56,     1,     0,
       0,    26,    20,    29,     0,    21,    22,    25,    27,    28,
       8,     0,    13,    15,     0,   116,    45,    48,    32,    95,
     110,     0,     3,    52,    53,    55,   113,   115,   121,   122,
       0,     0,     0,    31,     0,    58,    60,     0,    61,    65,
      63,    67,    79,    78,    80,    81,    82,   119,    83,     4,
      14,    16,     0,     0,    23,    24,     0,     0,     0,     9,
      46,    47,   117,     5,   114,   123,    38,    39,    40,    30,
      57,    59,    68,    64,    62,    66,    11,     0,     0,    26,
      17,    18,    19,    12
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -73,   -10,     0,   -16,   -73,   -54,   -67,   -66,   -73,   -72,
     -14,   -73,    -1,    41,    10,   -73,   -73,    32,   -73,   -73,
     -73,   -73,   -73,   -73,     1,   -29,    -4,   -73,   -15
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,    20,    21,    22,    23,    81,    82,    83,    24,    61,
      25,    63,    26,    64,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    65,    88,    66,    67
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_uint8 yytable[] =
{
      40,    39,    42,   120,   121,    62,    68,    80,    55,    38,
      43,    41,   100,   101,   102,    98,    44,    46,     8,    60,
     123,    96,    92,    69,    86,    47,    87,    94,   136,   137,
     138,   124,    91,   105,   110,   101,   102,    45,    39,   125,
      69,    95,    99,    97,   127,   128,    48,   106,   111,    49,
      50,   103,    51,    52,    53,    40,    39,    42,   122,   119,
      54,    86,   108,    87,   109,   129,    41,    89,    90,    40,
      39,    42,   150,   151,   152,   140,   132,   133,   144,   134,
      41,   120,   121,   130,   135,   131,    62,    62,    62,   141,
      85,    69,   145,   102,   146,   153,   128,    93,   118,   139,
      60,    60,    60,   130,     0,   131,   142,   147,   143,   126,
     127,   128,     1,     2,     0,     3,     0,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,     0,     0,     0,     0,     0,     0,     0,   148,   149,
      72,     0,    73,     0,     0,     0,     0,    19,    70,    71,
      72,     3,    73,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    75,    76,     0,
      77,    78,    79,     0,    74,     0,     0,    75,    76,     0,
      77,    78,    79,    19,    70,    71,    72,     3,    73,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    75,    76,     0,    77,    78,    79,    19,
       1,     2,     0,     3,     0,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,     0,
       0,     0,   149,    72,     0,    73,    18,     0,     0,     0,
       0,     1,     2,     0,     3,    19,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      75,    76,     0,    77,    78,    79,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    19,    38,    71,    72,
       3,    73,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    75,    76,     0,    77,
      78,    79,    56,     2,    57,     3,    58,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,     0,     0,     0,     0,     0,    59,    38,     2,    57,
       3,    58,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    84,     0,     0,     3,
       0,    59,     0,     6,     7,     0,     0,     0,    11,    12,
      13,    14,    15,    16,     2,     0,     0,     0,   112,   113,
      85,     0,     0,   114,   115,     0,     0,     0,     0,     0,
       0,   116,     0,    38,     2,     0,     3,   117,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,   104,     0,    57,     3,    58,     0,     0,     6,
       7,     0,     0,     0,    11,    12,    13,    14,    15,    16,
     107,     0,    57,     3,    58,     0,     0,     6,     7,     0,
       0,     0,    11,    12,    13,    14,    15,    16,    57,     3,
      58,     0,     0,     6,     7,     0,     0,     0,    11,    12,
      13,    14,    15,    16,     3,     0,     0,     0,     6,     7,
       0,     0,     0,    11,    12,    13,    14,    15,    16
};

static const yytype_int16 yycheck[] =
{
       1,     1,     1,    70,    70,    19,     0,    23,    18,     6,
      30,     1,     3,     4,     5,    10,     9,    30,    15,    19,
      74,     8,    33,    34,    25,    30,    25,    56,   100,   101,
     102,    37,    48,    62,    63,     4,     5,    30,    38,    37,
      34,    56,    37,    30,     4,     5,    32,    62,    63,    30,
      30,    42,    30,    30,    30,    56,    56,    56,    74,    69,
      30,    62,    63,    62,    63,    81,    56,    30,     9,    70,
      70,    70,   126,   127,   128,   104,    30,    33,   107,     8,
      70,   148,   148,    84,    37,    84,   100,   101,   102,   104,
      30,    34,   107,     5,    33,    33,     5,    56,    66,   103,
     100,   101,   102,   104,    -1,   104,   107,   123,   107,     3,
       4,     5,     6,     7,    -1,     9,    -1,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     6,     7,
       8,    -1,    10,    -1,    -1,    -1,    -1,    41,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    35,    36,    -1,
      38,    39,    40,    -1,    32,    -1,    -1,    35,    36,    -1,
      38,    39,    40,    41,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    35,    36,    -1,    38,    39,    40,    41,
       6,     7,    -1,     9,    -1,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    -1,
      -1,    -1,     7,     8,    -1,    10,    32,    -1,    -1,    -1,
      -1,     6,     7,    -1,     9,    41,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      35,    36,    -1,    38,    39,    40,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    41,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    35,    36,    -1,    38,
      39,    40,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    -1,    -1,    -1,    -1,    -1,    30,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,     6,    -1,    -1,     9,
      -1,    30,    -1,    13,    14,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,     7,    -1,    -1,    -1,    11,    12,
      30,    -1,    -1,    16,    17,    -1,    -1,    -1,    -1,    -1,
      -1,    24,    -1,     6,     7,    -1,     9,    30,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,     6,    -1,     8,     9,    10,    -1,    -1,    13,
      14,    -1,    -1,    -1,    18,    19,    20,    21,    22,    23,
       6,    -1,     8,     9,    10,    -1,    -1,    13,    14,    -1,
      -1,    -1,    18,    19,    20,    21,    22,    23,     8,     9,
      10,    -1,    -1,    13,    14,    -1,    -1,    -1,    18,    19,
      20,    21,    22,    23,     9,    -1,    -1,    -1,    13,    14,
      -1,    -1,    -1,    18,    19,    20,    21,    22,    23
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     6,     7,     9,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    32,    41,
      44,    45,    46,    47,    51,    53,    55,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,     6,    45,
      55,    57,    67,    30,     9,    30,    30,    30,    32,    30,
      30,    30,    30,    30,    30,    44,     6,     8,    10,    30,
      45,    52,    53,    54,    56,    68,    70,    71,     0,    34,
       6,     7,     8,    10,    32,    35,    36,    38,    39,    40,
      46,    48,    49,    50,     6,    30,    55,    67,    69,    30,
       9,    46,    33,    56,    68,    71,     8,    30,    10,    37,
       3,     4,     5,    42,     6,    68,    71,     6,    55,    67,
      68,    71,    11,    12,    16,    17,    24,    30,    60,    44,
      49,    50,    46,    48,    37,    37,     3,     4,     5,    46,
      55,    67,    30,    33,     8,    37,    52,    52,    52,    69,
      68,    71,    55,    67,    68,    71,    33,    46,     6,     7,
      48,    48,    48,    33
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    43,    44,    44,    44,    45,    45,    46,    46,    46,
      47,    47,    47,    48,    48,    48,    48,    48,    48,    48,
      49,    49,    49,    49,    49,    49,    49,    49,    49,    50,
      51,    51,    51,    51,    51,    52,    52,    52,    52,    52,
      52,    53,    53,    53,    53,    53,    53,    53,    53,    53,
      53,    54,    54,    54,    54,    54,    54,    54,    54,    54,
      54,    54,    54,    54,    54,    54,    54,    54,    54,    55,
      55,    55,    55,    55,    55,    55,    55,    56,    56,    56,
      56,    56,    56,    56,    57,    57,    57,    57,    57,    57,
      58,    58,    59,    59,    60,    60,    61,    61,    62,    62,
      63,    63,    64,    64,    65,    65,    66,    66,    67,    67,
      67,    67,    68,    68,    68,    68,    69,    69,    70,    70,
      71,    71,    71,    71
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     3,     3,     4,     2,     1,     2,     3,
       1,     4,     5,     1,     2,     1,     2,     3,     3,     3,
       1,     1,     1,     2,     2,     1,     1,     1,     1,     1,
       4,     3,     2,     1,     1,     1,     1,     1,     3,     3,
       3,     2,     1,     2,     1,     2,     3,     3,     2,     2,
       1,     1,     2,     2,     1,     2,     1,     3,     2,     3,
       2,     2,     3,     2,     3,     2,     3,     2,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     2,
       2,     2,     2,     2,     1,     1,     1,     1,     1,     1,
       1,     2,     1,     2,     2,     2,     1,     2,     1,     2,
       1,     2,     1,     2,     1,     2,     1,     2,     1,     2,
       3,     2,     1,     2,     3,     2,     1,     2,     1,     2,
       1,     2,     2,     3
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 95 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			SmartsParser::state.current_parser->setRoot((yyvsp[0].node));
			(yyval.node) = (yyvsp[0].node);			
		}
#line 1450 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 3:
#line 100 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			SmartsParser::state.current_parser->setNextComponentNumberToSubTree((yyvsp[-1].node));
			(yyval.node) = (yyvsp[-1].node);
		}
#line 1459 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 4:
#line 105 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			SmartsParser::state.current_parser->setRoot((yyvsp[-2].node));
			SmartsParser::state.current_parser->setComponentGrouping(true);
			SmartsParser::SPBond* b = new SmartsParser::SPBond(SmartsParser::SPBond::NOT_NECESSARILY_CONNECTED);
			SmartsParser::SPEdge* e = new SmartsParser::SPEdge();
			SmartsParser::state.current_parser->addEdge(e);
			e->setSPBond(b);
			e->setFirstSPNode((yyvsp[-2].node));
			e->setSecondSPNode((yyvsp[0].node));
			(yyvsp[-2].node)->addSPEdge(e);
			(yyval.node) = (yyvsp[-2].node);
		}
#line 1476 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 5:
#line 121 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyvsp[-1].node)->setRecursive(true);
			SmartsParser::state.current_parser->setRecursive(true);
			(yyval.node) = (yyvsp[-1].node);
		}
#line 1486 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 6:
#line 127 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyvsp[0].node)->setNot(true);
			(yyval.node) = (yyvsp[0].node);
		}
#line 1495 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 7:
#line 135 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.node) = (yyvsp[0].node);
		}
#line 1503 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 8:
#line 139 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			SmartsParser::SPBond* b = new SmartsParser::SPBond(SmartsParser::SPBond::SINGLE_OR_AROMATIC);
			SmartsParser::SPEdge* e = new SmartsParser::SPEdge();
			SmartsParser::state.current_parser->addEdge(e);
			e->setSPBond(b);
			e->setFirstSPNode((yyvsp[-1].node));
			e->setSecondSPNode((yyvsp[0].node));
			(yyvsp[-1].node)->addSPEdge(e);
			(yyval.node) = (yyvsp[-1].node);
		}
#line 1518 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 9:
#line 150 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyvsp[-1].edge)->setFirstSPNode((yyvsp[-2].node));
			(yyvsp[-1].edge)->setSecondSPNode((yyvsp[0].node));
			(yyvsp[-2].node)->addSPEdge((yyvsp[-1].edge));
			(yyval.node) = (yyvsp[-2].node);
		}
#line 1529 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 10:
#line 160 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.node) = (yyvsp[0].node);
		}
#line 1537 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 11:
#line 164 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			SmartsParser::SPEdge* e = new SmartsParser::SPEdge();
			SmartsParser::state.current_parser->addEdge(e);
			SmartsParser::SPBond* b = new SmartsParser::SPBond(SmartsParser::SPBond::SINGLE_OR_AROMATIC);
			e->setSPBond(b);
			e->setFirstSPNode((yyvsp[-3].node));
			e->setSecondSPNode((yyvsp[-1].node));
			(yyvsp[-3].node)->addSPEdge(e);
			(yyval.node) = (yyvsp[-3].node);
		}
#line 1552 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 12:
#line 175 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyvsp[-2].edge)->setFirstSPNode((yyvsp[-4].node));
			(yyvsp[-2].edge)->setSecondSPNode((yyvsp[-1].node));
			(yyvsp[-4].node)->addSPEdge((yyvsp[-2].edge));
			(yyval.node) = (yyvsp[-4].node);
		}
#line 1563 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 13:
#line 185 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			SmartsParser::SPEdge* e = new SmartsParser::SPEdge();
			SmartsParser::state.current_parser->addEdge(e);
			e->setSPBond((yyvsp[0].sp_bond));
			(yyval.edge) = e;
		}
#line 1574 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 14:
#line 192 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			SmartsParser::SPEdge* e = new SmartsParser::SPEdge();
			SmartsParser::state.current_parser->addEdge(e);
			e->setSPBond((yyvsp[0].sp_bond));
			e->setNot(true);
			(yyval.edge) = e;
		}
#line 1586 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 15:
#line 200 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			SmartsParser::SPEdge* e = new SmartsParser::SPEdge();
			SmartsParser::state.current_parser->addEdge(e);
			e->setSPBond((yyvsp[0].sp_bond));
			SmartsParser::state.current_parser->setNeedsSSSR(true);
			(yyval.edge) = e;
		}
#line 1598 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 16:
#line 208 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			SmartsParser::SPEdge* e = new SmartsParser::SPEdge();
			SmartsParser::state.current_parser->addEdge(e);
			e->setSPBond((yyvsp[0].sp_bond));
			SmartsParser::state.current_parser->setNeedsSSSR(true);
			(yyvsp[0].sp_bond)->setNot(true);
			(yyval.edge) = e;
		}
#line 1611 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 17:
#line 217 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			SmartsParser::SPEdge* e = new SmartsParser::SPEdge();
			SmartsParser::state.current_parser->addEdge(e);
			e->setInternal(true);
			e->setFirstSPEdge((yyvsp[-2].edge));
			e->setSecondSPEdge((yyvsp[0].edge));
			e->setLogicalOperator(SmartsParser::AND_LOW);
			(yyval.edge) = e;
		}
#line 1625 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 18:
#line 227 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			SmartsParser::SPEdge* e = new SmartsParser::SPEdge();
			SmartsParser::state.current_parser->addEdge(e);
			e->setInternal(true);
			e->setFirstSPEdge((yyvsp[-2].edge));
			e->setSecondSPEdge((yyvsp[0].edge));
			e->setLogicalOperator(SmartsParser::OR);
			(yyval.edge) = e;
		}
#line 1639 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 19:
#line 237 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			SmartsParser::SPEdge* e = new SmartsParser::SPEdge();
			SmartsParser::state.current_parser->addEdge(e);
			e->setInternal(true);
			e->setFirstSPEdge((yyvsp[-2].edge));
			e->setSecondSPEdge((yyvsp[0].edge));
			e->setLogicalOperator(SmartsParser::AND);
			(yyval.edge) = e;
		}
#line 1653 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 20:
#line 250 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.sp_bond) = new SmartsParser::SPBond(SmartsParser::SPBond::SINGLE);
		}
#line 1661 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 21:
#line 254 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
      (yyval.sp_bond) = new SmartsParser::SPBond(SmartsParser::SPBond::SINGLE_UP);
		}
#line 1669 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 22:
#line 258 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
      (yyval.sp_bond) = new SmartsParser::SPBond(SmartsParser::SPBond::SINGLE_DOWN);
		}
#line 1677 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 23:
#line 262 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.sp_bond) = new SmartsParser::SPBond(SmartsParser::SPBond::SINGLE_UP_OR_ANY);
		}
#line 1685 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 24:
#line 266 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.sp_bond) = new SmartsParser::SPBond(SmartsParser::SPBond::SINGLE_DOWN_OR_ANY);
		}
#line 1693 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 25:
#line 270 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
		  (yyval.sp_bond) = new SmartsParser::SPBond(SmartsParser::SPBond::DOUBLE);
		}
#line 1701 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 26:
#line 274 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
		  (yyval.sp_bond) = new SmartsParser::SPBond(SmartsParser::SPBond::TRIPLE);
		}
#line 1709 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 27:
#line 278 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
		  (yyval.sp_bond) = new SmartsParser::SPBond(SmartsParser::SPBond::AROMATIC);
		}
#line 1717 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 28:
#line 282 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
		  (yyval.sp_bond) = new SmartsParser::SPBond(SmartsParser::SPBond::ANY);
		}
#line 1725 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 29:
#line 289 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.sp_bond) = new SmartsParser::SPBond(SmartsParser::SPBond::IN_RING);
		}
#line 1733 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 30:
#line 296 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			//$2->setInBrackets();
			SmartsParser::state.current_parser->addRingConnection((yyvsp[-2].node), (yyvsp[0].number));
			(yyval.node) = (yyvsp[-2].node);
		}
#line 1743 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 31:
#line 302 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.node) = (yyvsp[-1].node);
		}
#line 1751 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 32:
#line 306 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.node) = new SmartsParser::SPNode((yyvsp[-1].atom));
			SmartsParser::state.current_parser->addNode((yyval.node));
			SmartsParser::state.current_parser->addRingConnection((yyval.node), (yyvsp[0].number));
		}
#line 1761 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 33:
#line 312 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.node) = new SmartsParser::SPNode((yyvsp[0].atom));
			SmartsParser::state.current_parser->addNode((yyval.node));
		}
#line 1770 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 34:
#line 317 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.node) = (yyvsp[0].node);
		}
#line 1778 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 35:
#line 325 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.node) = new SmartsParser::SPNode((yyvsp[0].atom));
			SmartsParser::state.current_parser->addNode((yyval.node));
		}
#line 1787 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 36:
#line 330 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.node) = new SmartsParser::SPNode((yyvsp[0].atom));
			SmartsParser::state.current_parser->addNode((yyval.node));
		}
#line 1796 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 37:
#line 335 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.node) = (yyvsp[0].node);
		}
#line 1804 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 38:
#line 339 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.node) = new SmartsParser::SPNode((yyvsp[-2].node), SmartsParser::AND_LOW, (yyvsp[0].node));
			SmartsParser::state.current_parser->addNode((yyval.node));
		}
#line 1813 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 39:
#line 344 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.node) = new SmartsParser::SPNode((yyvsp[-2].node), SmartsParser::OR, (yyvsp[0].node));
			SmartsParser::state.current_parser->addNode((yyval.node));
		}
#line 1822 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 40:
#line 349 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.node) = new SmartsParser::SPNode((yyvsp[-2].node), SmartsParser::AND, (yyvsp[0].node));
			SmartsParser::state.current_parser->addNode((yyval.node));
		}
#line 1831 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 41:
#line 357 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyvsp[0].atom)->setNotProperty(SmartsParser::SPAtom::SYMBOL);
			(yyval.atom) = (yyvsp[0].atom);
		}
#line 1840 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 42:
#line 362 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.atom) = (yyvsp[0].atom);
		}
#line 1848 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 43:
#line 366 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.atom) = new SmartsParser::SPAtom();
			(yyval.atom)->setNotProperty((yyvsp[0].property)->getType());
			(yyval.atom)->setProperty(*(yyvsp[0].property));
			delete (yyvsp[0].property);
		}
#line 1859 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 44:
#line 373 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.atom) = new SmartsParser::SPAtom();
			(yyval.atom)->setProperty(*(yyvsp[0].property));
			delete (yyvsp[0].property);
		}
#line 1869 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 45:
#line 379 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyvsp[-1].atom)->setProperty(*(yyvsp[0].property));
			(yyval.atom) = (yyvsp[-1].atom);
			delete (yyvsp[0].property);
		}
#line 1879 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 46:
#line 385 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyvsp[-2].atom)->setProperty(*(yyvsp[0].property));
			(yyvsp[-2].atom)->setNotProperty((yyvsp[0].property)->getType());
			delete (yyvsp[0].property);
			(yyval.atom) = (yyvsp[-2].atom);
		}
#line 1890 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 47:
#line 392 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyvsp[-2].atom)->setProperty(SmartsParser::SPAtom::CHARGE, (yyvsp[0].number));
			(yyvsp[-2].atom)->setNotProperty(SmartsParser::SPAtom::CHARGE);
			(yyval.atom) = (yyvsp[-2].atom);
		}
#line 1900 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 48:
#line 398 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyvsp[-1].atom)->setProperty(SmartsParser::SPAtom::CHARGE, (yyvsp[0].number));
			(yyval.atom) = (yyvsp[-1].atom);
		}
#line 1909 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 49:
#line 403 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.atom) = new SmartsParser::SPAtom();
			(yyval.atom)->setProperty(SmartsParser::SPAtom::CHARGE, (yyvsp[0].number));
			(yyval.atom)->setNotProperty(SmartsParser::SPAtom::CHARGE);
		}
#line 1919 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 50:
#line 409 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.atom) = new SmartsParser::SPAtom();
			(yyval.atom)->setProperty(SmartsParser::SPAtom::CHARGE, (yyvsp[0].number));
		}
#line 1928 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 51:
#line 417 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.atom) = (yyvsp[0].atom);
		}
#line 1936 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 52:
#line 421 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyvsp[0].atom)->setNotProperty(SmartsParser::SPAtom::SYMBOL);
			
			(yyval.atom) = (yyvsp[0].atom);
		}
#line 1946 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 53:
#line 427 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.atom) = new SmartsParser::SPAtom();
			(yyval.atom)->setProperty(SmartsParser::SPAtom::CHARGE, (yyvsp[0].number));
			(yyval.atom)->setNotProperty(SmartsParser::SPAtom::CHARGE);
		}
#line 1956 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 54:
#line 433 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.atom) = new SmartsParser::SPAtom();
			(yyval.atom)->setProperty(SmartsParser::SPAtom::CHARGE, (yyvsp[0].number));
		}
#line 1965 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 55:
#line 438 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.atom) = (yyvsp[0].atom);
			(yyval.atom)->setNotProperty(SmartsParser::SPAtom::CHIRALITY);
		}
#line 1974 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 56:
#line 443 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.atom) = (yyvsp[0].atom);
		}
#line 1982 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 57:
#line 447 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyvsp[-2].atom)->setProperty(SmartsParser::SPAtom::CHARGE, (yyvsp[0].number));
			(yyvsp[-2].atom)->setNotProperty(SmartsParser::SPAtom::CHARGE);
			(yyval.atom) = (yyvsp[-2].atom);
		}
#line 1992 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 58:
#line 453 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyvsp[-1].atom)->setProperty(SmartsParser::SPAtom::CHARGE, (yyvsp[0].number));
			(yyval.atom) = (yyvsp[-1].atom);
		}
#line 2001 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 59:
#line 458 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyvsp[-2].atom)->addPropertiesFromSPAtom((yyvsp[0].atom));
			(yyvsp[-2].atom)->setNotProperty(SmartsParser::SPAtom::CHIRALITY);
			delete (yyvsp[0].atom);
			(yyval.atom) = (yyvsp[-2].atom);
		}
#line 2012 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 60:
#line 465 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyvsp[-1].atom)->addPropertiesFromSPAtom((yyvsp[0].atom));
			delete (yyvsp[0].atom);
			(yyval.atom) = (yyvsp[-1].atom);
		}
#line 2022 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 61:
#line 471 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyvsp[-1].atom)->setProperty(*(yyvsp[0].property));
			delete (yyvsp[0].property);
			(yyval.atom) = (yyvsp[-1].atom);
		}
#line 2032 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 62:
#line 477 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyvsp[-2].atom)->setProperty(SmartsParser::SPAtom::CHARGE, (yyvsp[0].number));
			(yyvsp[-2].atom)->setNotProperty(SmartsParser::SPAtom::CHARGE);
			(yyval.atom) = (yyvsp[-2].atom);
		}
#line 2042 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 63:
#line 483 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyvsp[-1].atom)->setProperty(SmartsParser::SPAtom::CHARGE, (yyvsp[0].number));
			(yyval.atom) = (yyvsp[-1].atom);
		}
#line 2051 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 64:
#line 488 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyvsp[-2].atom)->setProperty(SmartsParser::SPAtom::CHARGE, (yyvsp[0].number));
			(yyvsp[-2].atom)->setNotProperty(SmartsParser::SPAtom::CHARGE);
			(yyval.atom) = (yyvsp[-2].atom);
		}
#line 2061 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 65:
#line 494 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyvsp[-1].atom)->setProperty(SmartsParser::SPAtom::CHARGE, (yyvsp[0].number));
			(yyval.atom) = (yyvsp[-1].atom);
		}
#line 2070 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 66:
#line 499 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyvsp[-2].atom)->setNotProperty(SmartsParser::SPAtom::CHIRALITY);
			(yyvsp[-2].atom)->addPropertiesFromSPAtom((yyvsp[0].atom));
			delete (yyvsp[0].atom);
			(yyval.atom) = (yyvsp[-2].atom);
		}
#line 2081 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 67:
#line 506 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyvsp[-1].atom)->addPropertiesFromSPAtom((yyvsp[0].atom));
			delete (yyvsp[0].atom);
			(yyval.atom) = (yyvsp[-1].atom);
		}
#line 2091 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 68:
#line 512 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyvsp[-2].atom)->setProperty(*(yyvsp[0].property));
			(yyvsp[-2].atom)->setNotProperty((yyvsp[0].property)->getType());
			delete (yyvsp[0].property);
			(yyval.atom) = (yyvsp[-2].atom);
		}
#line 2102 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 69:
#line 522 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.property) = new SmartsParser::SPAtom::Property(SmartsParser::SPAtom::IN_NUM_RINGS, (yyvsp[0].number));
			SmartsParser::state.current_parser->setNeedsSSSR(true);
		}
#line 2111 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 70:
#line 527 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.property) = new SmartsParser::SPAtom::Property(SmartsParser::SPAtom::IN_RING_SIZE, (yyvsp[0].number));
			SmartsParser::state.current_parser->setNeedsSSSR(true);
		}
#line 2120 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 71:
#line 532 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.property) = new SmartsParser::SPAtom::Property(SmartsParser::SPAtom::VALENCE, (yyvsp[0].number));
		}
#line 2128 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 72:
#line 536 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.property) = new SmartsParser::SPAtom::Property(SmartsParser::SPAtom::CONNECTED, (yyvsp[0].number));
		}
#line 2136 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 73:
#line 540 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.property) = new SmartsParser::SPAtom::Property(SmartsParser::SPAtom::IMPLICIT_HYDROGENS, (yyvsp[0].number));
		}
#line 2144 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 74:
#line 544 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.property) = new SmartsParser::SPAtom::Property(SmartsParser::SPAtom::EXPLICIT_HYDROGENS, (yyvsp[0].number));
		}
#line 2152 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 75:
#line 548 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.property) = new SmartsParser::SPAtom::Property(SmartsParser::SPAtom::DEGREE, (yyvsp[0].number));
		}
#line 2160 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 76:
#line 552 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.property) = new SmartsParser::SPAtom::Property(SmartsParser::SPAtom::RING_CONNECTED, (yyvsp[0].number));
		}
#line 2168 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 77:
#line 559 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.atom) = new SmartsParser::SPAtom();
			(yyval.atom)->setProperty(SmartsParser::SPAtom::ISOTOPE, (yyvsp[0].number));
		}
#line 2177 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 78:
#line 564 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.atom) = new SmartsParser::SPAtom((yyvsp[0].text));
			(yyval.atom)->setProperty(SmartsParser::SPAtom::ISOTOPE, (yyvsp[-1].number));
		}
#line 2186 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 79:
#line 569 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.atom) = new SmartsParser::SPAtom((yyvsp[0].text));
			(yyval.atom)->setProperty(SmartsParser::SPAtom::ISOTOPE, (yyvsp[-1].number));
		}
#line 2195 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 80:
#line 574 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.atom) = new SmartsParser::SPAtom((yyvsp[0].text));
			(yyval.atom)->setProperty(SmartsParser::SPAtom::ISOTOPE, (yyvsp[-1].number));
		}
#line 2204 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 81:
#line 579 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.atom) = new SmartsParser::SPAtom((yyvsp[0].text));
			(yyval.atom)->setProperty(SmartsParser::SPAtom::ISOTOPE, (yyvsp[-1].number));
		}
#line 2213 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 82:
#line 584 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.atom) = new SmartsParser::SPAtom();
			(yyval.atom)->setProperty(SmartsParser::SPAtom::ISOTOPE, (yyvsp[-1].number));
		}
#line 2222 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 83:
#line 589 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.atom) = new SmartsParser::SPAtom((yyvsp[0].number));
			(yyval.atom)->setProperty(SmartsParser::SPAtom::ISOTOPE, (yyvsp[-1].number));
		}
#line 2231 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 84:
#line 597 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.atom) = new SmartsParser::SPAtom((yyvsp[0].text));
		}
#line 2239 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 85:
#line 601 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.atom) = new SmartsParser::SPAtom();
			(yyval.atom)->setProperty(SmartsParser::SPAtom::AROMATIC, true);
		}
#line 2248 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 86:
#line 606 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.atom) = new SmartsParser::SPAtom();
			(yyval.atom)->setProperty(SmartsParser::SPAtom::ALIPHATIC, true);
		}
#line 2257 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 87:
#line 611 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.atom) = new SmartsParser::SPAtom();
		}
#line 2265 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 88:
#line 615 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.atom) = new SmartsParser::SPAtom((yyvsp[0].number));
		}
#line 2273 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 89:
#line 619 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.atom) = new SmartsParser::SPAtom((yyvsp[0].text));
		}
#line 2281 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 90:
#line 626 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.number) = 1;
		}
#line 2289 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 91:
#line 630 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.number) = (yyvsp[0].number);
		}
#line 2297 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 92:
#line 637 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.number) = 1;
		}
#line 2305 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 93:
#line 641 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.number) = (yyvsp[0].number);
		}
#line 2313 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 94:
#line 648 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    { 
			(yyval.number) = (yyvsp[0].number); 
		}
#line 2321 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 95:
#line 652 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.number) = 10 * (yyvsp[-1].number) + (yyvsp[0].number); 
		}
#line 2329 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 96:
#line 659 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.number) = 0;
		}
#line 2337 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 97:
#line 663 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.number) = (yyvsp[0].number);
		}
#line 2345 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 98:
#line 670 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.number) = 0;
		}
#line 2353 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 99:
#line 674 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.number) = (yyvsp[0].number);
		}
#line 2361 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 100:
#line 681 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.number) = 0;
		}
#line 2369 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 101:
#line 685 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.number) = (yyvsp[0].number);
		}
#line 2377 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 102:
#line 692 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.number) = 0;
		}
#line 2385 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 103:
#line 696 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.number) = (yyvsp[0].number);
		}
#line 2393 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 104:
#line 703 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.number) = 999;
		}
#line 2401 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 105:
#line 707 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.number) = (yyvsp[0].number);
		}
#line 2409 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 106:
#line 714 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.number) = 0;
		}
#line 2417 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 107:
#line 718 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.number) = (yyvsp[0].number);
		}
#line 2425 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 108:
#line 724 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    { (yyval.number) = 1; }
#line 2431 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 109:
#line 725 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    { (yyval.number) = 2; }
#line 2437 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 110:
#line 726 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    { (yyval.number) = 3; }
#line 2443 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 111:
#line 727 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    { (yyval.number) = (yyvsp[0].number); }
#line 2449 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 112:
#line 731 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {	(yyval.number) = -1; }
#line 2455 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 113:
#line 732 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    { (yyval.number) = -2; }
#line 2461 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 114:
#line 733 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    { (yyval.number) = -3; }
#line 2467 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 115:
#line 734 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    { (yyval.number) = -(yyvsp[0].number); }
#line 2473 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 116:
#line 739 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.number) = (yyvsp[0].number);
		}
#line 2481 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 117:
#line 743 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.number) = (yyvsp[-1].number) + 10 * (yyvsp[0].number);
		}
#line 2489 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 118:
#line 749 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    { (yyval.number) = (yyvsp[0].number);	}
#line 2495 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 119:
#line 750 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    { (yyval.number) = (yyvsp[-1].number) + 10 * (yyvsp[0].number); }
#line 2501 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 120:
#line 755 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.atom) = new SmartsParser::SPAtom();
			(yyval.atom)->setProperty(SmartsParser::SPAtom::CHIRALITY, SmartsParser::CCW_DEFAULT);
		}
#line 2510 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 121:
#line 760 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    { 
			(yyval.atom) = new SmartsParser::SPAtom();
			(yyval.atom)->setProperty(SmartsParser::SPAtom::CHIRALITY, SmartsParser::CW_DEFAULT);
		}
#line 2519 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 122:
#line 765 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.atom) = new SmartsParser::SPAtom();
			(yyval.atom)->setProperty(SmartsParser::SPAtom::CHIRALITY, SmartsParser::CCW_DEFAULT_OR_UNSPECIFIED);
		}
#line 2528 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;

  case 123:
#line 770 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1648  */
    {
			(yyval.atom) = new SmartsParser::SPAtom();
			(yyval.atom)->setProperty(SmartsParser::SPAtom::CHIRALITY, SmartsParser::CW_DEFAULT_OR_UNSPECIFIED);
		}
#line 2537 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
    break;


#line 2541 "/usr/src/RPM/BUILD/BALL-1.4.3_beta1.793.git37fc53c/BUILD/source/STRUCTURE/smartsParserParser.C" /* yacc.c:1648  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 776 "source/STRUCTURE/smartsParserParser.y" /* yacc.c:1907  */


void yyerror(char const* s)
{
	throw Exception::ParseError(__FILE__, 0, 
															SmartsParser::state.buffer, 
															String(s) + String(" (at position ") 
																+ String(SmartsParser::state.char_count) + String(")"));
}
